Index: bfd/elf32-m32r.c
===================================================================
RCS file: /cvs/src/src/bfd/elf32-m32r.c,v
retrieving revision 1.38
diff -c -r1.38 elf32-m32r.c
*** bfd/elf32-m32r.c	3 Dec 2003 17:38:48 -0000	1.38
--- bfd/elf32-m32r.c	18 Dec 2003 10:04:33 -0000
***************
*** 986,995 ****
    /* Assume success.  */
    bfd_boolean ret = TRUE;
  
! #if !USE_REL
!   if (info->relocatable)
!     return TRUE;
! #endif
  
    rel = relocs;
    relend = relocs + input_section->reloc_count;
--- 2534,2550 ----
    /* Assume success.  */
    bfd_boolean ret = TRUE;
  
!   struct elf_m32r_link_hash_table *htab = m32r_elf_hash_table (info);
!   bfd *dynobj;
!   bfd_vma *local_got_offsets;
!   asection *sgot, *splt, *sreloc;
! 
!   dynobj = htab->root.dynobj;
!   local_got_offsets = elf_local_got_offsets (input_bfd);
!                                                                                 
!   sgot = htab->sgot;
!   splt = htab->splt;
!   sreloc = NULL;
  
    rel = relocs;
    relend = relocs + input_section->reloc_count;
***************
*** 998,1015 ****
        int r_type;
        reloc_howto_type *howto;
        unsigned long r_symndx;
        /* We can't modify r_addend here as elf_link_input_bfd has an assert to
! 	 ensure it's zero (we use REL relocs, not RELA).  Therefore this
! 	 should be assigning zero to `addend', but for clarity we use
! 	 `r_addend'.  */
        bfd_vma addend = rel->r_addend;
        bfd_vma offset = rel->r_offset;
-       struct elf_link_hash_entry *h;
        Elf_Internal_Sym *sym;
        asection *sec;
        const char *sym_name;
        bfd_reloc_status_type r;
        const char *errmsg = NULL;
  
        h = NULL;
        r_type = ELF32_R_TYPE (rel->r_info);
--- 2553,2571 ----
        int r_type;
        reloc_howto_type *howto;
        unsigned long r_symndx;
+       struct elf_link_hash_entry *h;
        /* We can't modify r_addend here as elf_link_input_bfd has an assert to
!          ensure it's zero (we use REL relocs, not RELA).  Therefore this
!          should be assigning zero to `addend', but for clarity we use
!          `r_addend'.  */
        bfd_vma addend = rel->r_addend;
        bfd_vma offset = rel->r_offset;
        Elf_Internal_Sym *sym;
        asection *sec;
        const char *sym_name;
        bfd_reloc_status_type r;
        const char *errmsg = NULL;
+       bfd_boolean use_rel = FALSE;
  
        h = NULL;
        r_type = ELF32_R_TYPE (rel->r_info);
***************
*** 1024,1037 ****
  	}
  
        if (r_type == R_M32R_GNU_VTENTRY
!           || r_type == R_M32R_GNU_VTINHERIT)
          continue;
  
        howto = m32r_elf_howto_table + r_type;
        r_symndx = ELF32_R_SYM (rel->r_info);
  
! #if USE_REL
!       if (info->relocatable)
  	{
  	  /* This is a relocatable link.  We don't have to change
  	     anything, unless the reloc is against a section symbol,
--- 2580,2598 ----
  	}
  
        if (r_type == R_M32R_GNU_VTENTRY
!           || r_type == R_M32R_GNU_VTINHERIT
!           || r_type == R_M32R_NONE
!           || r_type == R_M32R_RELA_GNU_VTENTRY
!           || r_type == R_M32R_RELA_GNU_VTINHERIT)
          continue;
  
+       if (r_type <= R_M32R_GNU_VTENTRY)
+         use_rel = TRUE;
+ 
        howto = m32r_elf_howto_table + r_type;
        r_symndx = ELF32_R_SYM (rel->r_info);
  
!       if (info->relocatable && (use_rel == TRUE))
  	{
  	  /* This is a relocatable link.  We don't have to change
  	     anything, unless the reloc is against a section symbol,
***************
*** 1092,1104 ****
  	    }
  	}
        else
- #endif /* USE_REL */
  	{
  	  bfd_vma relocation;
  
  	  /* This is a final link.  */
  	  sym = NULL;
  	  sec = NULL;
  
  	  if (r_symndx < symtab_hdr->sh_info)
  	    {
--- 2653,2665 ----
  	    }
  	}
        else
  	{
  	  bfd_vma relocation;
  
  	  /* This is a final link.  */
  	  sym = NULL;
  	  sec = NULL;
+           h = NULL;
  
  	  if (r_symndx < symtab_hdr->sh_info)
  	    {
***************
*** 1106,1125 ****
  	      sym = local_syms + r_symndx;
  	      sec = local_sections[r_symndx];
  	      sym_name = "<local symbol>";
! #if !USE_REL
! 	      relocation = _bfd_elf_rela_local_sym (output_bfd, sym, &sec, rel);
! 	      addend = rel->r_addend;
! #else
! 	      /* FIXME: This won't handle local relocations against SEC_MERGE
! 		 symbols.  See elf32-i386.c for how to do this.  */
! 	      relocation = (sec->output_section->vma
! 			    + sec->output_offset
! 			    + sym->st_value);
! #endif
  	    }
  	  else
  	    {
  	      /* External symbol.  */
  	      h = sym_hashes[r_symndx - symtab_hdr->sh_info];
  	      while (h->root.type == bfd_link_hash_indirect
  		     || h->root.type == bfd_link_hash_warning)
--- 2667,2703 ----
  	      sym = local_syms + r_symndx;
  	      sec = local_sections[r_symndx];
  	      sym_name = "<local symbol>";
! 
!               if (use_rel == FALSE)
!                 {
! 	          relocation = _bfd_elf_rela_local_sym (output_bfd, sym, &sec, rel);
! 	          addend = rel->r_addend;
! 
!                   if (info->relocatable)
!                     {
!                       /* This is a relocatable link.  We don't have to change
!                          anything, unless the reloc is against a section symbol,
!                          in which case we have to adjust according to where the
!                          section symbol winds up in the output section.  */
!                       if (ELF_ST_TYPE (sym->st_info) == STT_SECTION)
!                         rel->r_addend += sec->output_offset + sym->st_value;
!                                                                                 
!                       continue;
!                     }
!                 }
!               else
!                 {
! 	          relocation = (sec->output_section->vma
! 			        + sec->output_offset
! 			        + sym->st_value);
!                 }
  	    }
  	  else
  	    {
  	      /* External symbol.  */
+               if (info->relocatable && (use_rel == FALSE))
+                 continue;
+ 
  	      h = sym_hashes[r_symndx - symtab_hdr->sh_info];
  	      while (h->root.type == bfd_link_hash_indirect
  		     || h->root.type == bfd_link_hash_warning)
***************
*** 1129,1137 ****
  	      if (h->root.type == bfd_link_hash_defined
  		  || h->root.type == bfd_link_hash_defweak)
  		{
  		  sec = h->root.u.def.section;
! 		  if (sec->output_section == NULL)
! 		    relocation = 0;
  		  else
  		    relocation = (h->root.u.def.value
  				  + sec->output_section->vma
--- 2707,2770 ----
  	      if (h->root.type == bfd_link_hash_defined
  		  || h->root.type == bfd_link_hash_defweak)
  		{
+ 	          bfd_boolean dyn;
  		  sec = h->root.u.def.section;
! 
! 	          dyn = htab->root.dynamic_sections_created;
!                   sec = h->root.u.def.section;
!                   if (r_type == R_M32R_GOTPC24
!                       || (r_type == R_M32R_GOTPC_HI_ULO
!                           || r_type == R_M32R_GOTPC_HI_SLO
!                           || r_type == R_M32R_GOTPC_LO)
!                       || (r_type == R_M32R_26_PLTREL
!                           && h->plt.offset != (bfd_vma) -1)
!                       || ((r_type == R_M32R_GOT24
!                            || r_type == R_M32R_GOT16_HI_ULO
!                            || r_type == R_M32R_GOT16_HI_SLO
!                            || r_type == R_M32R_GOT16_LO)
!                           && WILL_CALL_FINISH_DYNAMIC_SYMBOL (dyn, info, h)
!                           && (! info->shared
!                               || (! info->symbolic && h->dynindx != -1)
!                               || (h->elf_link_hash_flags
!                                   & ELF_LINK_HASH_DEF_REGULAR) == 0))
!                       || (info->shared
!                           && ((! info->symbolic && h->dynindx != -1)
!                               || (h->elf_link_hash_flags
!                                   & ELF_LINK_HASH_DEF_REGULAR) == 0)
!                           && (((r_type == R_M32R_16_RELA
!                               || r_type == R_M32R_32_RELA
!                               || r_type == R_M32R_24_RELA
!                               || r_type == R_M32R_HI16_ULO_RELA
!                               || r_type == R_M32R_HI16_SLO_RELA
!                               || r_type == R_M32R_LO16_RELA)
! 			          && (h->elf_link_hash_flags
! 				      & ELF_LINK_FORCED_LOCAL) == 0)
!                               || r_type == R_M32R_10_PCREL_RELA
!                               || r_type == R_M32R_18_PCREL_RELA
!                               || r_type == R_M32R_26_PCREL_RELA)
!                           && ((input_section->flags & SEC_ALLOC) != 0
!                               /* DWARF will emit R_M32R_16(24,32) relocations
!                                  in its sections against symbols defined 
!                                  externally in shared libraries.  We can't do
!                                  anything with them here.  */
!                               || ((input_section->flags & SEC_DEBUGGING) != 0
!                                   && (h->elf_link_hash_flags
!                                       & ELF_LINK_HASH_DEF_DYNAMIC) != 0))))
!                     {
!                       /* In these cases, we don't need the relocation
!                          value.  We check specially because in some
!                          obscure cases sec->output_section will be NULL.  */
!                       relocation = 0;
!                     }
! 		  else if (sec->output_section == NULL)
!                     {
!                       (*_bfd_error_handler)
!                         (_("%s: warning: unresolvable relocation against symbol `%s' from %s section"),
!                          bfd_get_filename (input_bfd), h->root.root.string,
!                          bfd_get_section_name (input_bfd, input_section));
! 
! 		       relocation = 0;
!                     }
  		  else
  		    relocation = (h->root.u.def.value
  				  + sec->output_section->vma
***************
*** 1139,1149 ****
  		}
  	      else if (h->root.type == bfd_link_hash_undefweak)
  		relocation = 0;
  	      else
  		{
  		  if (! ((*info->callbacks->undefined_symbol)
  			 (info, h->root.root.string, input_bfd,
! 			  input_section, offset, TRUE)))
  		    return FALSE;
  		  relocation = 0;
  		}
--- 2772,2788 ----
  		}
  	      else if (h->root.type == bfd_link_hash_undefweak)
  		relocation = 0;
+               else if (info->shared
+                        && (!info->symbolic)
+                        && ELF_ST_VISIBILITY (h->other) == STV_DEFAULT)
+                 relocation = 0;
  	      else
  		{
  		  if (! ((*info->callbacks->undefined_symbol)
  			 (info, h->root.root.string, input_bfd,
! 			  input_section, offset,
!                           (!info->shared 
!                            || ELF_ST_VISIBILITY (h->other)))))
  		    return FALSE;
  		  relocation = 0;
  		}
***************
*** 1158,1168 ****
  
  	  switch ((int) r_type)
  	    {
  	    case (int) R_M32R_10_PCREL :
  	      r = m32r_elf_do_10_pcrel_reloc (input_bfd, howto, input_section,
  					      contents, offset,
  					      sec, relocation, addend);
! 	      break;
  
  	    case (int) R_M32R_HI16_SLO :
  	    case (int) R_M32R_HI16_ULO :
--- 2797,3079 ----
  
  	  switch ((int) r_type)
  	    {
+             case R_M32R_GOTPC24:
+               /* .got(_GLOBAL_OFFSET_TABLE_) - pc relocation
+                  ld24 rx,#_GLOBAL_OFFSET_TABLE_
+                */
+              relocation = sgot->output_section->vma;
+              break;
+ 
+             case R_M32R_GOTPC_HI_ULO:
+             case R_M32R_GOTPC_HI_SLO:
+             case R_M32R_GOTPC_LO: 
+               {
+                 /* .got(_GLOBAL_OFFSET_TABLE_) - pc relocation
+                    bl .+4
+                    seth rx,#high(_GLOBAL_OFFSET_TABLE_)
+                    or3 rx,rx,#low(_GLOBAL_OFFSET_TABLE_ +4)
+                    or
+                    bl .+4
+                    seth rx,#shigh(_GLOBAL_OFFSET_TABLE_)
+                    add3 rx,rx,#low(_GLOBAL_OFFSET_TABLE_ +4)
+                  */
+                 relocation = sgot->output_section->vma;
+                 relocation -= (input_section->output_section->vma
+                                + input_section->output_offset
+                                + rel->r_offset);
+                 if ((r_type == R_M32R_GOTPC_HI_SLO) 
+                      && ((relocation + rel->r_addend) & 0x8000))
+                   rel->r_addend += 0x10000;
+ 
+                 break;
+               }
+             case R_M32R_GOT16_HI_ULO:
+             case R_M32R_GOT16_HI_SLO:
+             case R_M32R_GOT16_LO: 
+               /* Fall through.  */
+             case R_M32R_GOT24:
+               /* Relocation is to the entry for this symbol in the global
+                  offset table.  */
+               BFD_ASSERT (sgot != NULL);
+  
+               if (h != NULL)
+                 {
+                   bfd_boolean dyn;
+                   bfd_vma off;
+  
+                   off = h->got.offset;
+                   BFD_ASSERT (off != (bfd_vma) -1);
+ 
+                   dyn = htab->root.dynamic_sections_created;
+                   if (! WILL_CALL_FINISH_DYNAMIC_SYMBOL (dyn, info, h)
+                       || (info->shared
+                           && (info->symbolic
+                               || h->dynindx == -1
+                               || (h->elf_link_hash_flags & ELF_LINK_FORCED_LOCAL))
+                           && (h->elf_link_hash_flags & ELF_LINK_HASH_DEF_REGULAR)))
+                     {
+                       /* This is actually a static link, or it is a
+                          -Bsymbolic link and the symbol is defined
+                          locally, or the symbol was forced to be local
+                          because of a version file.  We must initialize
+                          this entry in the global offset table.  Since the
+                          offset must always be a multiple of 4, we use the
+                          least significant bit to record whether we have
+                          initialized it already.
+  
+                          When doing a dynamic link, we create a .rela.got
+                          relocation entry to initialize the value.  This
+                          is done in the finish_dynamic_symbol routine.  */
+                       if ((off & 1) != 0)
+                         off &= ~1;
+                       else
+                         {
+                           bfd_put_32 (output_bfd, relocation,
+                                       sgot->contents + off);
+                           h->got.offset |= 1;
+                         }
+                     }
+  
+                   relocation = sgot->output_offset + off;
+                 }
+               else
+                 {
+                   bfd_vma off;
+                   bfd_byte *loc;
+  
+                   BFD_ASSERT (local_got_offsets != NULL
+                               && local_got_offsets[r_symndx] != (bfd_vma) -1);
+  
+                   off = local_got_offsets[r_symndx];
+  
+                   /* The offset must always be a multiple of 4.  We use
+                      the least significant bit to record whether we have
+                      already processed this entry.  */
+                   if ((off & 1) != 0)
+                     off &= ~1;
+                   else
+                     {
+                       bfd_put_32 (output_bfd, relocation, sgot->contents + off);
+  
+                       if (info->shared)
+                         {
+                           asection *srelgot;
+                           Elf_Internal_Rela outrel;
+  
+                           /* We need to generate a R_M32R_RELATIVE reloc
+                              for the dynamic linker.  */
+                           srelgot = bfd_get_section_by_name (dynobj, ".rela.got");
+                           BFD_ASSERT (srelgot != NULL);
+  
+                           outrel.r_offset = (sgot->output_section->vma
+                                              + sgot->output_offset
+                                              + off);
+                           outrel.r_info = ELF32_R_INFO (0, R_M32R_RELATIVE);
+                           outrel.r_addend = relocation;
+                           loc = srelgot->contents;
+                           loc += srelgot->reloc_count * sizeof(Elf32_External_Rela);
+                           bfd_elf32_swap_reloca_out (output_bfd, &outrel,loc);
+                           ++srelgot->reloc_count;
+                         }
+  
+                       local_got_offsets[r_symndx] |= 1;
+                     }
+  
+                   relocation = sgot->output_offset + off;
+                 }
+               if ((r_type == R_M32R_GOT16_HI_SLO)
+                   && ((relocation + rel->r_addend) & 0x8000))
+                 rel->r_addend += 0x10000;
+ 
+               break;
+  
+             case R_M32R_26_PLTREL:
+               /* Relocation is to the entry for this symbol in the
+                  procedure linkage table.  */
+  
+               /* The native assembler will generate a 26_PLTREL reloc
+                  for a local symbol if you assemble a call from one
+                  section to another when using -K pic. */
+               if (h == NULL)
+                 break;
+ 
+               //if (ELF_ST_VISIBILITY (h->other) == STV_INTERNAL
+               //    || ELF_ST_VISIBILITY (h->other) == STV_HIDDEN)
+               //  break;
+               if (h->elf_link_hash_flags & ELF_LINK_FORCED_LOCAL)
+                 break;
+ 
+               if (h->plt.offset == (bfd_vma) -1)
+                 {
+                   /* We didn't make a PLT entry for this symbol.  This
+                      happens when statically linking PIC code, or when
+                      using -Bsymbolic.  */
+                   break;
+                 }
+  
+               relocation = (splt->output_section->vma
+                             + splt->output_offset
+                             + h->plt.offset);
+               break;
+  
+             case R_M32R_HI16_SLO_RELA:
+               {
+                  if ((relocation + rel->r_addend) & 0x8000)
+                    {
+                      rel->r_addend += 0x10000;
+                    }
+               }
+               /* Fall through.  */
+             case R_M32R_16_RELA:
+             case R_M32R_24_RELA:
+             case R_M32R_32_RELA:
+             case R_M32R_18_PCREL_RELA:
+             case R_M32R_26_PCREL_RELA:
+             case R_M32R_HI16_ULO_RELA:
+             case R_M32R_LO16_RELA:
+             case R_M32R_SDA16_RELA:
+               if (info->shared
+                   && r_symndx != 0
+                   && (input_section->flags & SEC_ALLOC) != 0
+                   && ((r_type != R_M32R_18_PCREL_RELA
+                        && r_type != R_M32R_26_PCREL_RELA)
+                       || (h != NULL
+                           && h->dynindx != -1
+                           && (! info->symbolic
+                               || (h->elf_link_hash_flags
+                                   & ELF_LINK_HASH_DEF_REGULAR) == 0))))
+                 {
+                   Elf_Internal_Rela outrel;
+                   bfd_boolean skip, relocate;
+                   bfd_byte *loc;
+  
+                   /* When generating a shared object, these relocations
+                      are copied into the output file to be resolved at run
+                      time.  */
+  
+                   if (sreloc == NULL)
+                     {
+                       const char *name;
+  
+                       name = (bfd_elf_string_from_elf_section
+                               (input_bfd,
+                                elf_elfheader (input_bfd)->e_shstrndx,
+                                elf_section_data (input_section)->rel_hdr.sh_name));
+                       if (name == NULL)
+                         return FALSE;
+  
+                       BFD_ASSERT (strncmp (name, ".rela", 5) == 0
+                                   && strcmp (bfd_get_section_name (input_bfd,
+                                                                    input_section),
+                                              name + 5) == 0);
+  
+                       sreloc = bfd_get_section_by_name (dynobj, name);
+                       BFD_ASSERT (sreloc != NULL);
+                     }
+  
+                   skip = FALSE;
+                   relocate = FALSE;
+  
+                   outrel.r_offset = _bfd_elf_section_offset (output_bfd,
+                                                              info,
+                                                              input_section,
+                                                              rel->r_offset);
+                   if (outrel.r_offset == (bfd_vma) -1)
+                     skip = TRUE;
+                   else if (outrel.r_offset == (bfd_vma) -2)
+                     skip = TRUE, relocate = TRUE;
+                   outrel.r_offset += (input_section->output_section->vma
+                                       + input_section->output_offset);
+  
+                   if (skip)
+                     memset (&outrel, 0, sizeof outrel);
+                   else if (r_type == R_M32R_18_PCREL_RELA
+                            || r_type == R_M32R_26_PCREL_RELA)
+                     {
+                       BFD_ASSERT (h != NULL && h->dynindx != -1);
+                       outrel.r_info = ELF32_R_INFO (h->dynindx, r_type);
+                       outrel.r_addend = rel->r_addend;
+                     }
+                   else
+                     {
+                     /* h->dynindx may be -1 if this symbol was marked to
+                        become local.  */
+                     if (h == NULL
+                         || ((info->symbolic || h->dynindx == -1)
+                              && (h->elf_link_hash_flags
+                                  & ELF_LINK_HASH_DEF_REGULAR) != 0))
+                       {
+                         relocate = TRUE;
+                         outrel.r_info = ELF32_R_INFO (0, R_M32R_RELATIVE);
+                         outrel.r_addend = relocation + rel->r_addend;
+                       }
+                     else
+                       {
+                         BFD_ASSERT (h->dynindx != -1);
+                         outrel.r_info = ELF32_R_INFO (h->dynindx, r_type);
+                         outrel.r_addend = relocation + rel->r_addend;
+                       }
+                     }
+ 
+                   loc = sreloc->contents;
+                   loc += sreloc->reloc_count * sizeof(Elf32_External_Rela);
+                   bfd_elf32_swap_reloca_out (output_bfd, &outrel,loc);
+                   ++sreloc->reloc_count;
+ 
+                   /* If this reloc is against an external symbol, we do
+                      not want to fiddle with the addend.  Otherwise, we
+                      need to include the symbol value so that it becomes
+                      an addend for the dynamic reloc.  */
+                   if (! relocate)
+                     continue;
+                 }
+               break;
+  
  	    case (int) R_M32R_10_PCREL :
  	      r = m32r_elf_do_10_pcrel_reloc (input_bfd, howto, input_section,
  					      contents, offset,
  					      sec, relocation, addend);
!               goto check_reloc;
  
  	    case (int) R_M32R_HI16_SLO :
  	    case (int) R_M32R_HI16_ULO :
***************
*** 1190,1196 ****
  						contents, offset,
  						relocation, addend);
  	      }
! 	      break;
  
  	    case (int) R_M32R_SDA16 :
  	      {
--- 3101,3108 ----
  						contents, offset,
  						relocation, addend);
  	      }
! 
!               goto check_reloc;
  
  	    case (int) R_M32R_SDA16 :
  	      {
***************
*** 1233,1246 ****
  		    continue;
  		  }
  	      }
! 	      /* fall through */
  
- 	    default :
  	      r = _bfd_final_link_relocate (howto, input_bfd, input_section,
  					    contents, offset,
  					    relocation, addend);
! 	      break;
  	    }
  	}
  
      check_reloc:
--- 3145,3164 ----
  		    continue;
  		  }
  	      }
!               /* fall through */
! 
! 	    default : /* OLD_M32R_RELOC */
  
  	      r = _bfd_final_link_relocate (howto, input_bfd, input_section,
  					    contents, offset,
  					    relocation, addend);
! 	      goto check_reloc;
  	    }
+ 
+           r = _bfd_final_link_relocate (howto, input_bfd, input_section,
+                                         contents, rel->r_offset,
+                                         relocation, rel->r_addend);
+ 
  	}
  
      check_reloc:
